/**
 * Bundle of @devexpress/dx-react-chart-bootstrap4
 * Generated: 2018-11-07
 * Version: 1.9.0
 * License: https://js.devexpress.com/Licensing
 */

(function (global, factory) {
  typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@devexpress/dx-react-chart'), require('classnames'), require('react'), require('prop-types')) :
  typeof define === 'function' && define.amd ? define(['exports', '@devexpress/dx-react-chart', 'classnames', 'react', 'prop-types'], factory) :
  (factory((global.DevExpress = global.DevExpress || {}, global.DevExpress.DXReactChartBootstrap4 = {}),global.DevExpress.DXReactChart,global.classNames,global.React,global.PropTypes));
}(this, (function (exports,dxReactChart,classNames,React,PropTypes) { 'use strict';

  if (typeof process === "undefined") { var process = { env: {} }; }

  classNames = classNames && classNames.hasOwnProperty('default') ? classNames['default'] : classNames;

  var classCallCheck = function (instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  };

  var createClass = function () {
    function defineProperties(target, props) {
      for (var i = 0; i < props.length; i++) {
        var descriptor = props[i];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if ("value" in descriptor) descriptor.writable = true;
        Object.defineProperty(target, descriptor.key, descriptor);
      }
    }

    return function (Constructor, protoProps, staticProps) {
      if (protoProps) defineProperties(Constructor.prototype, protoProps);
      if (staticProps) defineProperties(Constructor, staticProps);
      return Constructor;
    };
  }();

  var _extends = Object.assign || function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];

      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }

    return target;
  };

  var inherits = function (subClass, superClass) {
    if (typeof superClass !== "function" && superClass !== null) {
      throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);
    }

    subClass.prototype = Object.create(superClass && superClass.prototype, {
      constructor: {
        value: subClass,
        enumerable: false,
        writable: true,
        configurable: true
      }
    });
    if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;
  };

  var objectWithoutProperties = function (obj, keys) {
    var target = {};

    for (var i in obj) {
      if (keys.indexOf(i) >= 0) continue;
      if (!Object.prototype.hasOwnProperty.call(obj, i)) continue;
      target[i] = obj[i];
    }

    return target;
  };

  var possibleConstructorReturn = function (self, call) {
    if (!self) {
      throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
    }

    return call && (typeof call === "object" || typeof call === "function") ? call : self;
  };

  var withClassName = function withClassName() {
    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    var setClassName = function setClassName(_ref) {
      var className = _ref.className,
          restProps = objectWithoutProperties(_ref, ['className']);
      return _extends({
        className: classNames.apply(undefined, args.concat([className]))
      }, restProps);
    };
    return dxReactChart.withPatchedProps(setClassName);
  };

  var Root = withClassName('dx-c-bs4-container')(dxReactChart.Chart.Root);

  var Label = withClassName('dx-c-bs4-fill-current-color', 'dx-c-bs4-label', 'text-muted')(dxReactChart.Chart.Label);

  var palette = ['#0070ff', '#d72e3d', '#249d3d', '#ffb90c', '#1698af', '#616a72'];

  var ChartWithPalette = function ChartWithPalette(_ref) {
    var children = _ref.children,
        props = objectWithoutProperties(_ref, ['children']);
    return React.createElement(
      dxReactChart.Chart,
      props,
      React.createElement(dxReactChart.Palette, { scheme: palette }),
      children
    );
  };

  ChartWithPalette.components = dxReactChart.Chart.components;

  process.env.NODE_ENV !== "production" ? ChartWithPalette.propTypes = {
    children: PropTypes.node.isRequired
  } : void 0;

  var Chart = dxReactChart.withComponents({ Root: Root })(ChartWithPalette);
  Chart.Label = Label;

  var Root$1 = withClassName('list-group', 'py-3')(function (props) {
    return React.createElement('ul', props);
  });

  var Label$1 = withClassName('text-body', 'pl-2', 'pr-2')(function (_ref) {
    var text = _ref.text,
        restProps = objectWithoutProperties(_ref, ['text']);
    return React.createElement(
      'span',
      restProps,
      text
    );
  });

  var Item = withClassName('d-flex', 'list-group-item', 'border-0', 'py-1', 'px-4', 'align-items-center')(function (props) {
    return React.createElement('li', props);
  });

  var Legend = dxReactChart.withComponents({
    Root: Root$1, Item: Item, Label: Label$1
  })(dxReactChart.Legend);

  var Text = function (_React$PureComponent) {
    inherits(Text, _React$PureComponent);

    function Text() {
      classCallCheck(this, Text);
      return possibleConstructorReturn(this, (Text.__proto__ || Object.getPrototypeOf(Text)).apply(this, arguments));
    }

    createClass(Text, [{
      key: 'render',
      value: function render() {
        var _props = this.props,
            text = _props.text,
            restProps = objectWithoutProperties(_props, ['text']);

        return React.createElement(
          'h3',
          restProps,
          text
        );
      }
    }]);
    return Text;
  }(React.PureComponent);

  process.env.NODE_ENV !== "production" ? Text.propTypes = {
    text: PropTypes.oneOfType([PropTypes.string, PropTypes.number]).isRequired
  } : void 0;

  var Title = dxReactChart.withComponents({ Text: Text })(dxReactChart.Title);

  var setClassName = function setClassName(_ref) {
    var classes = _ref.classes,
        restProps = objectWithoutProperties(_ref, ['classes']);

    if (restProps.state) {
      var className = restProps.className,
          rest = objectWithoutProperties(restProps, ['className']);

      return _extends({
        className: classNames('dx-c-bs4-fill-background-color', className)
      }, rest);
    }
    return restProps;
  };

  var Point = dxReactChart.withPatchedProps(setClassName)(dxReactChart.ScatterSeries.Point);

  var ScatterSeries = dxReactChart.withComponents({ Point: Point })(dxReactChart.ScatterSeries);

  var Line = withClassName('dx-c-bs4-stroke-current-color', 'dx-c-bs4-crisp-edges', 'dx-c-bs4-axis-opacity')(dxReactChart.Grid.Line);

  var ValueGrid = dxReactChart.withComponents({ Line: Line })(dxReactChart.ValueGrid);

  var ArgumentGrid = dxReactChart.withComponents({ Line: Line })(dxReactChart.ArgumentGrid);

  var Root$2 = withClassName('dx-c-bs4-crisp-edges')(dxReactChart.Axis.Root);

  var Tick = withClassName('dx-c-bs4-stroke-current-color', 'dx-c-bs4-crisp-edges', 'dx-c-bs4-axis-opacity')(dxReactChart.Axis.Tick);

  var Label$2 = withClassName('dx-c-bs4-fill-current-color', 'dx-c-bs4-label', 'text-muted')(dxReactChart.Axis.Label);

  var Line$1 = withClassName('dx-c-bs4-stroke-current-color', 'dx-c-bs4-axis-opacity')(dxReactChart.Axis.Line);

  var ValueAxis = dxReactChart.withComponents({
    Root: Root$2, Tick: Tick, Label: Label$2, Line: Line$1
  })(dxReactChart.ValueAxis);

  var ArgumentAxis = dxReactChart.withComponents({
    Root: Root$2, Tick: Tick, Label: Label$2, Line: Line$1
  })(dxReactChart.ArgumentAxis);

  exports.AreaSeries = dxReactChart.AreaSeries;
  exports.BarSeries = dxReactChart.BarSeries;
  exports.LineSeries = dxReactChart.LineSeries;
  exports.PieSeries = dxReactChart.PieSeries;
  exports.SplineSeries = dxReactChart.SplineSeries;
  exports.Chart = Chart;
  exports.Legend = Legend;
  exports.Title = Title;
  exports.ScatterSeries = ScatterSeries;
  exports.ValueGrid = ValueGrid;
  exports.ArgumentGrid = ArgumentGrid;
  exports.ValueAxis = ValueAxis;
  exports.ArgumentAxis = ArgumentAxis;

  Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=dx-react-chart-bootstrap4.umd.js.map
